;CHRNO=0
; A=USR(CHRNO),X,Y+2,XSIZ-1,YSIZ-1 (XSIZ,YSIZ:0-9)
;CHRNO=1-23
; A=USR(CHRNO),X,Y+2

FTOI2	equ	0741h		;de=2-byte integer converted from float
GETINT1	equ	0de4h		;a,de=1-byte integer
XY2AD	equ	11cdh		;h=x+1,l=y+1 -> hl=VRAM address
PROGAD	equ	0ff4eh		;program address work

;load size
	dw	PUTEND-0e000h

	org	0e000h

DATATBL:
;00h
	db	10, 10		;dummy
	dw	0ffffh, 0ffffh	;dummy
;01h
	db	10, 10
	dw	I1, I1A
;02h
	db	14, 10
	dw	I2, I2A
;03h
	db	10, 10
	dw	I3, I3A
;04h
	db	10, 10
	dw	I4, I4A
;05h
	db	10, 10
	dw	I5, I5A
;06h
	db	4,  2
	dw	IT, ITA
;07h
	db	10, 10
	dw	E1, E1A
;08h
	db	14, 10
	dw	E2, E2A
;09h
	db	10, 10
	dw	E3, E3A
;0ah
	db	10, 10
	dw	E4, E4A
;0bh
	db	10, 10
	dw	E5, E5A
;0ch
	db	5,  4
	dw	ET, ETA
;0dh
	db	8,  2
	dw	J1, J1A
;0eh
	db	7,  10
	dw	HS, HSA
;0fh
	db	5,  5
	dw	BH, BHA
;10h
	db	7,  6
	dw	J3, J3A
;11h
	db	10, 9
	dw	J2, J2A
;12h
	db	5,  2
	dw	A1, A1A
;13h
	db	5,  2
	dw	A2, A2A
;14h
	db	7,  5
	dw	J4, J4A
;15h
	db	17, 19
	dw	BIG1, BIG1A
;16h
	db	18, 19
	dw	BIG2, BIG2A
;17h
	db	19, 19
	dw	BIG3, BIG3A
;18h
	db	7,  9
	dw	HS2, HS2A

PUT:
	call	FTOI2		;de=CHRNO
	ld	a,e
	pop	hl		;return address
	ex	(sp),hl		;program address
	push	af
	inc	hl
	call	GETINT1		;a=de=X
	push	af
	inc	hl
	call	GETINT1		;a=de=Y
	pop	bc		;b=X

;for Ho-suke
	cp	04h
	jr	nc,YGE4
	pop	af		;a=CHRNO
	cp	15h
	jr	nc,YOK		;big character
	inc	e
	or	a
	jr	z,YOK
	ld	a,18h
	jr	YOK
YGE4:
	pop	af		;a=CHRNO
YOK:
	ex	(sp),hl		;program address
	push	hl		;return address

	ld	h,b		;X
	ld	l,e		;Y
	inc	h		;X+1
;	inc	l
	dec	l		;(Y-2)+1
	call	XY2AD
	push	hl		;VRAM address

	add	a,a		;CHRNO*2
	jr	z,CLEAR

;CHRNO>0
	ld	b,a
	add	a,a		;CHRNO*4
	add	a,b		;CHRNO*6
	ld	h,DATATBL/256
	ld	l,a
	ld	a,(hl)		;xsize
	ld	(XSIZE1+2),a
	inc	hl
	ld	a,(hl)		;ysize
	inc	hl

	ld	e,(hl)		;character code data address
	inc	hl
	ld	d,(hl)
	inc	hl

	push	hl
	exx
	pop	hl
	ld	e,(hl)		;attribute data address
	inc	hl
	ld	d,(hl)
	ex	de,hl
	exx

	pop	hl		;VRAM address
	ex	de,hl

;de=VRAM address, hl/hl'=data address, a=ysize, (XSIZE1+2)=xsize
PUTLP1:
	push	de
	exx
	pop	de
	res	2,d		;attribute
	exx
XSIZE1:
	ld	bc,0028h
PUTLP2:
	ldi
	exx
	ldi
	exx
	djnz	PUTLP2

	ex	de,hl
	add	hl,bc		;b=0
	ex	de,hl

	dec	a
	jr	nz,PUTLP1
	ret


CLEAR:
	pop	bc		;VRAM address
	pop	de		;return address
	pop	hl		;program address
	push	de
	push	bc
	inc	hl

	ld	a,(hl)
	sub	'0'-1
	ld	(XSIZE2+1),a	;xsize
	inc	hl
	inc	hl
	ld	a,(hl)
	sub	'0'-1		;ysize
	inc	hl
	ld	(PROGAD),hl

	pop	de		;VRAM address
	ex	(sp),hl		;program address
	push	hl		;return address

	ex	de,hl
	res	2,h
	ld	de,0028h

;hl=attribute address, (XSIZE2+1)=xsize, a=ysize
CLRLP1:
	push	hl
XSIZE2:
	ld	b,00h
CLRLP2:
	ld	(hl),d		;=0
	inc	hl
	djnz	CLRLP2

	pop	hl
	add	hl,de

	dec	a
	jr	nz,CLRLP1
	ret


I1:
	db	021h,020h,020h,021h,020h,020h,020h,02bh,020h,020h
	db	022h,00fh,00fh,021h,00fh,00fh,00fh,020h,020h,02bh
	db	022h,00fh,00fh,019h,00fh,00fh,00fh,01dh,02eh,020h
	db	020h,020h,022h,023h,00fh,01bh,00fh,020h,020h,020h
	db	020h,020h,00fh,00fh,022h,00fh,023h,020h,020h,020h
	db	020h,020h,02eh,020h,00fh,019h,020h,020h,020h,020h
	db	020h,02bh,020h,020h,00fh,01ch,020h,02bh,020h,020h
	db	020h,020h,020h,020h,022h,00fh,021h,020h,020h,020h
	db	020h,02eh,020h,02bh,020h,019h,023h,020h,02eh,020h
	db	020h,020h,020h,020h,020h,00fh,020h,020h,02bh,020h

I1A:
	db	08ch,000h,000h,089h,000h,089h,000h,00eh,000h,000h
	db	08ch,08ch,08ch,08ch,089h,08ch,08ch,000h,000h,00eh
	db	08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch,00eh,000h
	db	000h,000h,08ch,08ch,08ch,08bh,08bh,000h,000h,000h
	db	000h,000h,08bh,08bh,08bh,08bh,08bh,000h,000h,000h
	db	000h,000h,00eh,000h,08bh,08bh,000h,000h,000h,000h
	db	000h,00eh,000h,000h,08bh,08bh,000h,00eh,000h,000h
	db	000h,000h,000h,000h,08bh,08bh,08bh,000h,000h,000h
	db	000h,00eh,000h,00eh,000h,08bh,08bh,000h,00eh,000h
	db	000h,000h,000h,000h,000h,08bh,000h,000h,00eh,000h

I2:
	db	020h,020h,020h,020h,021h,020h,020h,000h,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,00fh,021h,00fh,00fh,00fh,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,00fh,019h,00fh,00fh,00fh,01dh,000h,000h,000h,000h,000h
	db	020h,020h,020h,00fh,019h,00fh,01bh,00fh,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,00fh,00fh,022h,00fh,023h,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,00fh,023h,020h,018h,021h,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,023h,021h,00fh,01ch,022h,085h,000h,000h,000h,000h,000h
	db	020h,020h,020h,02fh,020h,00fh,00fh,021h,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,020h,020h,022h,021h,021h,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,020h,020h,020h,023h,022h,021h,000h,000h,000h,000h,000h

I2A:
	db	000h,000h,000h,000h,089h,000h,089h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,08ch,08ch,089h,08ch,08ch,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,08ch,08ch,08ch,08ch,08ch,08ch,000h,000h,000h,000h,000h
	db	000h,000h,000h,08ch,08ch,08ch,08bh,08bh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,08ch,08ch,08bh,08bh,08bh,000h,000h,000h,000h,000h,000h
	db	000h,000h,08ch,08ch,08ch,08dh,08fh,08fh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,08ch,089h,08dh,08dh,08fh,00bh,000h,000h,000h,000h,000h
	db	000h,000h,000h,009h,089h,089h,089h,089h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,08fh,08fh,08fh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,089h,089h,089h,089h,000h,000h,000h,000h,000h

I3:
	db	020h,020h,020h,021h,020h,020h,020h,020h,020h,020h
	db	020h,020h,020h,021h,00fh,00fh,00fh,020h,020h,020h
	db	021h,020h,00fh,019h,00fh,00fh,00fh,01dh,020h,020h
	db	022h,00fh,00fh,023h,00fh,01bh,00fh,020h,020h,020h
	db	022h,023h,020h,020h,022h,00fh,023h,020h,01ch,020h
	db	020h,020h,020h,020h,020h,018h,018h,00fh,01ch,020h
	db	020h,020h,010h,021h,00fh,01ch,020h,020h,020h,020h
	db	020h,020h,020h,020h,00fh,00fh,021h,020h,020h,020h
	db	020h,020h,020h,020h,023h,022h,021h,020h,020h,020h
	db	020h,020h,020h,023h,020h,020h,00fh,020h,020h,020h

I3A:
	db	000h,000h,000h,089h,000h,089h,000h,000h,000h,000h
	db	000h,000h,08ch,08ch,089h,08ch,08ch,000h,000h,000h
	db	08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch,000h,000h
	db	08ch,08ch,08ch,08ch,08ch,08bh,08bh,000h,000h,000h
	db	08ch,08ch,000h,000h,08bh,08bh,08bh,000h,08bh,000h
	db	000h,000h,000h,000h,08dh,08fh,08fh,089h,08bh,000h
	db	000h,000h,089h,089h,08dh,08dh,000h,000h,000h,000h
	db	000h,000h,000h,089h,089h,089h,089h,000h,000h,000h
	db	000h,000h,000h,08fh,08fh,08fh,08fh,000h,000h,000h
	db	000h,000h,089h,089h,000h,000h,089h,000h,000h,000h

I4:
	db	020h,020h,020h,020h,020h,020h,020h,0a1h,000h,000h
	db	00fh,00fh,000h,000h,000h,000h,000h,000h,000h,000h
	db	00fh,00fh,021h,020h,020h,020h,02eh,000h,000h,000h
	db	022h,00fh,00fh,00fh,00fh,00fh,020h,020h,0a1h,000h
	db	020h,00fh,019h,00fh,00fh,00fh,01dh,000h,000h,000h
	db	020h,022h,023h,00fh,01bh,00fh,000h,000h,000h,000h
	db	020h,020h,020h,022h,00fh,023h,00fh,000h,000h,000h
	db	020h,020h,020h,020h,00fh,018h,00fh,000h,000h,000h
	db	020h,020h,00fh,023h,00fh,01ch,020h,021h,000h,000h
	db	020h,020h,020h,020h,022h,00fh,023h,022h,021h,000h

I4A:
	db	08ch,08ch,000h,000h,000h,000h,000h,00fh,000h,000h
	db	08ch,08ch,000h,000h,000h,000h,000h,000h,000h,000h
	db	08ch,08ch,089h,000h,089h,000h,00fh,000h,000h,000h
	db	08ch,08ch,08ch,089h,08ch,08ch,000h,000h,00fh,000h
	db	000h,08ch,08ch,08ch,08ch,08ch,08ch,000h,000h,000h
	db	000h,08ch,08ch,08ch,08bh,08bh,000h,000h,000h,000h
	db	000h,000h,000h,08bh,08bh,08bh,08bh,000h,000h,000h
	db	000h,000h,000h,08fh,08dh,08fh,08fh,000h,000h,000h
	db	000h,000h,08bh,08fh,08dh,08dh,08fh,08fh,000h,000h
	db	000h,000h,000h,089h,089h,089h,08fh,089h,089h,000h

I5:
	db	020h,020h,020h,021h,020h,020h,020h,020h,020h,020h
	db	0dbh,020h,020h,021h,00fh,00fh,00fh,020h,020h,020h
	db	022h,00fh,00fh,019h,00fh,00fh,00fh,01dh,020h,020h
	db	022h,00fh,085h,021h,00fh,01bh,00fh,020h,020h,020h
	db	020h,020h,020h,022h,022h,00fh,023h,020h,020h,000h
	db	020h,020h,020h,021h,00fh,01ch,020h,020h,020h,020h
	db	020h,020h,02fh,020h,00fh,00fh,021h,000h,000h,000h
	db	020h,020h,020h,020h,022h,021h,021h,000h,000h,000h
	db	020h,020h,020h,020h,00fh,023h,023h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h

I5A:
	db	000h,000h,000h,089h,000h,089h,000h,000h,000h,000h
	db	08ch,000h,08ch,08ch,089h,08ch,08ch,000h,000h,000h
	db	08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch,000h,000h
	db	08ch,08ch,00bh,08fh,08ch,08bh,08bh,000h,000h,000h
	db	000h,000h,000h,08fh,08bh,08bh,08bh,000h,000h,000h
	db	000h,000h,000h,089h,08dh,08dh,000h,000h,000h,000h
	db	000h,000h,009h,089h,089h,089h,089h,000h,000h,000h
	db	000h,000h,000h,000h,08fh,08fh,08fh,000h,000h,000h
	db	000h,000h,000h,000h,089h,08fh,08fh,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h

IT:
	db	0dbh,0dbh,022h,021h
	db	02fh,02fh,020h,023h

ITA:
	db	08eh,08eh,08eh,08eh
	db	00eh,00eh,08eh,08eh

E1:
	db	020h,020h,023h,02fh,020h,021h,021h,020h,02bh,020h
	db	00fh,00fh,023h,020h,00fh,00fh,00fh,020h,020h,020h
	db	022h,00fh,021h,00fh,00fh,00fh,00fh,01ch,020h,020h
	db	0dbh,00fh,019h,00fh,00fh,01bh,00fh,020h,020h,020h
	db	020h,00fh,00fh,021h,00fh,00fh,023h,020h,02eh,020h
	db	020h,020h,020h,00fh,00fh,020h,020h,020h,020h,020h
	db	020h,02bh,020h,00fh,01ch,020h,02eh,020h,020h,020h
	db	020h,020h,02bh,022h,00fh,00fh,021h,020h,020h,020h
	db	020h,020h,020h,020h,022h,021h,00fh,02bh,020h,020h
	db	020h,020h,020h,020h,020h,022h,021h,020h,020h,020h

E1A:
	db	089h,089h,089h,009h,000h,089h,089h,000h,00eh,000h
	db	089h,089h,089h,089h,089h,089h,089h,000h,000h,000h
	db	089h,089h,089h,089h,089h,089h,089h,089h,000h,000h
	db	089h,089h,089h,089h,089h,08bh,08bh,000h,000h,000h
	db	000h,08bh,08bh,08bh,08bh,08bh,08bh,000h,00eh,000h
	db	000h,000h,089h,08bh,08bh,000h,000h,000h,000h,000h
	db	000h,00eh,000h,08bh,08bh,000h,00eh,000h,000h,000h
	db	000h,000h,00eh,08bh,08bh,08bh,08bh,000h,000h,000h
	db	000h,000h,000h,000h,08bh,08bh,08bh,00eh,000h,000h
	db	000h,000h,000h,000h,000h,08bh,08bh,000h,000h,000h

E2:
	db	020h,020h,020h,020h,0dbh,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,020h,020h,00fh,00fh,00fh,020h,000h,000h,000h,000h,000h
	db	020h,020h,020h,020h,00fh,00fh,00fh,00fh,01ch,000h,000h,000h,000h,000h
	db	020h,020h,021h,021h,00fh,00fh,01bh,00fh,020h,020h,020h,020h,000h,000h
	db	020h,020h,022h,00fh,00fh,00fh,00fh,023h,020h,020h,020h,023h,000h,000h
	db	020h,020h,020h,00fh,023h,018h,021h,020h,020h,020h,023h,020h,000h,000h
	db	020h,020h,00fh,00fh,020h,00fh,00fh,00fh,085h,023h,020h,020h,000h,000h
	db	020h,020h,022h,020h,00fh,00fh,021h,000h,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,020h,020h,023h,022h,021h,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,020h,023h,020h,020h,00fh,000h,000h,000h,000h,000h,000h

E2A:
	db	000h,000h,000h,000h,089h,000h,000h,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,089h,089h,089h,089h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,089h,089h,089h,089h,089h,000h,000h,000h,000h,000h
	db	000h,000h,089h,089h,089h,089h,08bh,08bh,000h,000h,000h,08eh,000h,000h
	db	000h,000h,089h,089h,089h,08bh,08bh,08bh,000h,000h,08eh,08eh,000h,000h
	db	000h,000h,089h,089h,089h,08fh,08ch,000h,000h,08eh,08eh,000h,000h,000h
	db	000h,000h,089h,089h,08fh,08fh,08fh,08ch,00bh,08eh,000h,000h,000h,000h
	db	000h,000h,089h,08fh,08fh,08ch,08ch,000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,08bh,08bh,08bh,08bh,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,08ch,08ch,000h,000h,08ch,000h,000h,000h,000h,000h,000h

E3:
	db	020h,020h,020h,020h,0dbh,020h,020h,020h,020h,020h
	db	020h,020h,020h,020h,020h,00fh,00fh,00fh,020h,020h
	db	022h,00fh,021h,020h,00fh,00fh,00fh,00fh,01ch,020h
	db	022h,00fh,00fh,019h,00fh,00fh,01bh,00fh,020h,020h
	db	020h,022h,00fh,019h,00fh,00fh,00fh,023h,020h,020h
	db	020h,020h,023h,023h,020h,018h,018h,018h,00fh,085h
	db	020h,020h,020h,020h,023h,00fh,01dh,020h,020h,020h
	db	020h,022h,00fh,023h,020h,00fh,00fh,021h,020h,020h
	db	020h,020h,020h,020h,023h,020h,020h,023h,020h,020h
	db	020h,020h,020h,023h,020h,020h,00fh,021h,020h,020h

E3A:
	db	000h,000h,000h,000h,089h,000h,000h,000h,000h,000h
	db	089h,000h,000h,000h,089h,089h,089h,089h,000h,000h
	db	089h,089h,089h,000h,089h,089h,089h,089h,089h,000h
	db	089h,089h,089h,089h,089h,089h,08bh,08bh,000h,000h
	db	000h,089h,089h,089h,089h,08bh,08bh,08bh,000h,000h
	db	000h,089h,089h,089h,08fh,08fh,08fh,08fh,08ch,00bh
	db	000h,000h,000h,08fh,08fh,08bh,08bh,000h,000h,000h
	db	000h,08fh,08fh,08fh,08ch,08ch,08bh,08bh,000h,000h
	db	000h,000h,000h,08bh,08bh,000h,08bh,08bh,000h,000h
	db	000h,000h,08ch,08ch,000h,000h,08ch,08ch,000h,000h

E4:
	db	021h,020h,020h,020h,020h,02eh,000h,000h,000h,000h
	db	00fh,00fh,023h,02fh,020h,020h,020h,020h,02eh,000h
	db	022h,00fh,020h,00fh,00fh,00fh,020h,0a1h,000h,000h
	db	022h,019h,00fh,00fh,00fh,00fh,01dh,020h,020h,000h
	db	020h,020h,00fh,00fh,01bh,00fh,020h,020h,023h,000h
	db	020h,020h,022h,00fh,00fh,023h,020h,023h,000h,000h
	db	020h,020h,020h,018h,018h,00fh,085h,000h,000h,000h
	db	022h,00fh,00fh,00fh,00fh,000h,000h,000h,000h,000h
	db	020h,022h,023h,00fh,01dh,020h,021h,00fh,023h,000h
	db	020h,020h,020h,022h,00fh,023h,022h,021h,000h,000h

E4A:
	db	089h,089h,000h,000h,000h,00fh,000h,000h,000h,000h
	db	089h,089h,089h,009h,000h,000h,000h,000h,00fh,000h
	db	089h,089h,089h,089h,089h,089h,000h,00fh,000h,000h
	db	089h,089h,089h,089h,089h,089h,089h,000h,08eh,000h
	db	000h,089h,089h,089h,08bh,08bh,000h,08eh,08eh,000h
	db	000h,000h,089h,08bh,08bh,08bh,08eh,08eh,000h,000h
	db	000h,000h,000h,08fh,08fh,08ch,00bh,000h,000h,000h
	db	08fh,08fh,08fh,08ch,08ch,000h,000h,000h,000h,000h
	db	000h,08fh,08fh,08bh,08bh,08bh,08bh,08ch,08ch,000h
	db	000h,000h,000h,08ch,08ch,08bh,08ch,08ch,000h,000h

E5:
	db	020h,020h,020h,0dbh,020h,020h,020h,020h,020h,020h
	db	020h,00fh,021h,020h,00fh,00fh,00fh,020h,020h,020h
	db	022h,00fh,019h,00fh,00fh,00fh,00fh,01dh,020h,020h
	db	022h,00fh,019h,00fh,00fh,01bh,00fh,020h,020h,020h
	db	020h,020h,00fh,018h,018h,00fh,023h,020h,020h,020h
	db	020h,020h,00fh,00fh,00fh,020h,020h,020h,020h,020h
	db	020h,085h,00fh,00fh,00fh,023h,020h,020h,020h,020h
	db	020h,020h,023h,022h,00fh,021h,000h,000h,000h,000h
	db	020h,020h,020h,020h,020h,023h,000h,000h,000h,000h
	db	020h,000h,000h,000h,000h,000h,000h,000h,000h,000h

E5A:
	db	000h,089h,000h,089h,000h,000h,089h,000h,000h,000h
	db	000h,089h,089h,089h,089h,089h,089h,000h,000h,000h
	db	089h,089h,089h,089h,089h,089h,089h,089h,000h,000h
	db	089h,089h,089h,089h,089h,08bh,08bh,000h,000h,000h
	db	000h,089h,089h,08fh,08fh,08bh,08bh,000h,000h,000h
	db	000h,08fh,08fh,08fh,08ch,000h,000h,000h,000h,000h
	db	000h,00bh,08eh,08eh,08eh,08eh,000h,000h,000h,000h
	db	000h,08fh,08fh,08ch,08bh,08bh,000h,000h,000h,000h
	db	000h,000h,000h,000h,08ch,08bh,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h,000h,000h,000h

ET:
	db	00fh,00fh,00fh,00fh,023h
	db	020h,02fh,02fh,02fh,02fh
	db	020h,02fh,02fh,020h,020h
	db	02fh,020h,020h,020h,020h

ETA:
	db	08eh,08eh,08eh,08eh,08eh
	db	000h,00bh,00bh,00bh,00bh
	db	000h,00bh,00bh,000h,000h
	db	00bh,000h,000h,000h,000h

J1:
	db	020h,085h,019h,019h,019h,021h,000h,000h
	db	018h,020h,019h,019h,019h,019h,000h,000h

J1A:
	db	08fh,009h,08fh,08fh,08fh,08fh,000h,000h
	db	00eh,000h,00eh,00eh,00eh,00eh,000h,000h

HS:
	db	020h,000h,000h,000h,000h,000h,000h
HS2:
	db	020h,000h,000h,000h,000h,000h,000h
	db	010h,010h,010h,010h,010h,020h,020h
	db	0dbh,02eh,020h,02eh,02fh,020h,020h
	db	019h,020h,041h,020h,01fh,020h,020h
	db	02dh,020h,020h,020h,02dh,020h,020h
	db	020h,0dbh,010h,010h,0cch,020h,020h
	db	020h,020h,01ah,01ah,020h,020h,020h
	db	000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h

HSA:
	db	000h,000h,000h,000h,000h,000h,000h
HS2A:
	db	000h,000h,000h,000h,000h,000h,000h
	db	08fh,08fh,08fh,08fh,08fh,000h,000h
	db	08fh,00fh,000h,00fh,00fh,000h,000h
	db	0f0h,000h,00fh,000h,08fh,000h,000h
	db	00fh,000h,000h,000h,00fh,000h,000h
	db	000h,08fh,08fh,08fh,00fh,000h,000h
	db	000h,000h,00fh,00fh,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h

BH:
	db	000h,000h,000h,000h,000h
	db	020h,02eh,020h,020h,02eh
	db	02eh,0a1h,020h,02eh,020h
	db	020h,020h,06fh,0a1h,020h
	db	02eh,020h,0a1h,020h,02eh

BHA:
	db	000h,000h,000h,000h,000h
	db	000h,009h,000h,000h,009h
	db	009h,009h,000h,009h,000h
	db	000h,000h,009h,009h,000h
	db	009h,000h,009h,000h,009h

J3:
	db	000h,000h,000h,000h,000h,000h,000h
	db	020h,020h,020h,020h,021h,000h,000h
	db	020h,00fh,020h,021h,000h,000h,000h
	db	00fh,085h,021h,021h,000h,000h,000h
	db	023h,022h,00fh,023h,022h,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h

J3A:
	db	000h,000h,000h,000h,000h,000h,000h
	db	000h,000h,000h,08fh,08fh,000h,000h
	db	08fh,08fh,08fh,08fh,000h,000h,000h
	db	08fh,009h,08fh,08fh,000h,000h,000h
	db	08fh,08eh,08eh,08eh,08eh,000h,000h
	db	000h,000h,000h,000h,000h,000h,000h

J2:
	db	020h,00fh,00fh,020h,020h,020h,020h,020h,020h,020h
	db	00fh,085h,00fh,021h,00fh,00fh,021h,020h,020h,020h
	db	00fh,00fh,00fh,022h,00fh,00fh,00fh,00fh,021h,020h
	db	022h,00fh,023h,00fh,00fh,00fh,022h,00fh,00fh,020h
	db	020h,020h,022h,00fh,00fh,018h,018h,018h,023h,020h
	db	020h,020h,020h,00fh,00fh,00fh,00fh,020h,020h,020h
	db	020h,020h,00fh,00fh,019h,00fh,00fh,021h,020h,020h
	db	020h,00fh,00fh,023h,020h,022h,00fh,00fh,00fh,020h
	db	018h,018h,00fh,020h,020h,020h,018h,018h,00fh,020h

J2A:
	db	08fh,08fh,08fh,000h,000h,000h,000h,000h,000h,000h
	db	08fh,009h,08fh,08fh,08fh,08fh,08fh,000h,000h,000h
	db	08fh,08fh,08fh,08fh,08fh,08fh,08fh,08fh,08fh,000h
	db	08fh,08fh,08fh,08fh,08fh,08fh,08fh,08fh,08fh,000h
	db	000h,000h,08eh,08eh,08eh,08eh,00bh,00bh,08fh,000h
	db	000h,000h,000h,08fh,08fh,08fh,08eh,000h,000h,000h
	db	000h,08fh,08fh,08eh,08eh,08fh,08eh,08eh,000h,000h
	db	000h,08eh,08eh,08eh,000h,08fh,08fh,08eh,08eh,000h
	db	00bh,00bh,08eh,000h,000h,000h,00bh,00bh,08eh,000h

A1:
	db	020h,020h,00fh,00fh,019h
	db	018h,018h,00fh,00fh,00fh

A1A:
	db	000h,08fh,08fh,08fh,08fh
	db	00bh,00bh,08fh,08fh,08fh

A2:
	db	020h,020h,020h,020h,00fh
	db	020h,020h,020h,018h,018h

A2A:
	db	000h,000h,000h,08fh,08fh
	db	000h,000h,000h,00bh,00bh

J4:
	db	020h,085h,021h,000h,000h,000h,000h
	db	022h,00fh,00fh,000h,000h,000h,000h
	db	018h,018h,00fh,000h,000h,000h,000h
	db	020h,018h,00fh,021h,000h,000h,000h
	db	020h,020h,020h,022h,023h,000h,000h

J4A:
	db	08fh,009h,08fh,000h,000h,000h,000h
	db	08fh,08fh,08fh,000h,000h,000h,000h
	db	00fh,08fh,08fh,000h,000h,000h,000h
	db	000h,08eh,08eh,08fh,000h,000h,000h
	db	08eh,000h,08eh,08eh,08eh,000h,000h

BIG1:
	db	020h,020h,020h,022h,021h,020h,020h,023h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,021h,000h
	db	020h,00fh,00fh,021h,022h,020h,023h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,021h
	db	020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,023h,00fh,00fh,020h,00fh,00fh
	db	020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,023h,00fh,00fh,020h,00fh,00fh,020h,021h,00fh
	db	020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,020h,00fh,023h,020h,00fh,023h,020h,00fh,00fh
	db	020h,00fh,00fh,00fh,00fh,00fh,00fh,023h,020h,023h,020h,018h,023h,020h,00fh,018h,023h
	db	020h,00fh,00fh,00fh,00fh,019h,00fh,00fh,023h,023h,02eh,014h,020h,00fh,02eh,014h,02fh
	db	020h,022h,00fh,00fh,00fh,019h,00fh,00fh,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,020h
	db	020h,020h,00fh,00fh,00fh,019h,022h,00fh,020h,00fh,00fh,00fh,00fh,019h,00fh,00fh,000h
	db	020h,020h,00fh,00fh,00fh,019h,020h,022h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,023h,000h
	db	020h,020h,00fh,00fh,00fh,019h,020h,020h,022h,00fh,00fh,018h,00fh,00fh,023h,021h,020h
	db	020h,020h,00fh,00fh,00fh,023h,020h,023h,020h,00fh,00fh,00fh,00fh,023h,020h,022h,01fh
	db	020h,020h,00fh,00fh,00fh,020h,020h,01fh,020h,00fh,00fh,020h,020h,020h,020h,020h,01fh
	db	020h,00fh,00fh,00fh,023h,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,021h,000h,000h,000h
	db	020h,00fh,00fh,00fh,020h,00fh,00fh,00fh,018h,00fh,018h,00fh,00fh,00fh,021h,000h,000h
	db	020h,00fh,00fh,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,021h,000h
	db	00fh,00fh,020h,00fh,00fh,020h,00fh,00fh,019h,00fh,00fh,00fh,019h,00fh,00fh,02fh,01fh
	db	022h,020h,00fh,00fh,023h,00fh,00fh,00fh,019h,00fh,00fh,00fh,019h,00fh,00fh,02fh,020h
	db	020h,00fh,00fh,023h,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,000h,000h

BIG1A:
	db	000h,000h,000h,089h,089h,000h,089h,089h,08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch,000h
	db	000h,08ch,08ch,08ch,089h,000h,089h,08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch
	db	000h,08ch,08ch,08ch,08ch,089h,08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch,000h,08ch,08ch
	db	000h,08ch,08ch,08ch,08ch,089h,08ch,08ch,08ch,08ch,08ch,000h,08ch,08ch,000h,08bh,08ch
	db	000h,08ch,08ch,08ch,08ch,089h,08ch,08ch,000h,08ch,08ch,08bh,08ch,08ch,08bh,08bh,08ch
	db	000h,08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch,08bh,08bh,08ch,08bh,08bh,08bh,08ch
	db	000h,08ch,08ch,08ch,08ch,08ch,08ch,08ch,08ch,08bh,00fh,08bh,08bh,08bh,00fh,08bh,00ch
	db	000h,08ch,08ch,08ch,08ch,08ch,08ch,08ch,000h,08bh,08ch,08bh,08bh,08bh,08ch,08bh,000h
	db	000h,000h,08ch,08ch,08ch,08ch,08ch,08ch,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,000h
	db	000h,000h,08ch,08ch,08ch,08ch,000h,08ch,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,000h
	db	000h,000h,08ch,08ch,08ch,08ch,000h,08ch,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08ch,000h
	db	000h,000h,08ch,08ch,08ch,08ch,000h,08ch,000h,08bh,08bh,08bh,08bh,08bh,000h,08ch,08ch
	db	000h,08ch,08ch,08ch,08ch,000h,000h,08ch,000h,08bh,08bh,000h,000h,000h,000h,000h,08ch
	db	000h,08ch,08ch,08ch,08ch,08bh,08eh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,000h,000h,000h
	db	000h,08ch,08ch,08ch,08bh,08bh,08eh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,000h,000h
	db	08ch,08ch,08ch,08bh,08bh,08bh,08eh,08bh,08bh,08bh,08bh,08bh,08eh,08eh,08eh,08eh,000h
	db	08ch,08ch,08bh,08bh,08bh,08eh,08eh,08bh,08bh,08bh,08bh,08eh,08bh,08bh,08bh,00eh,08eh
	db	08ch,08bh,08bh,08bh,08bh,08eh,08eh,08eh,08bh,08bh,08eh,08eh,08bh,08bh,08bh,00eh,000h
	db	08bh,08bh,08bh,08bh,000h,08eh,08eh,08eh,08eh,08eh,08eh,08eh,08eh,08bh,08bh,000h,000h

BIG2:
	db	020h,020h,02fh,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,021h,02fh,000h,000h
	db	020h,020h,01fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,021h,000h,000h
	db	020h,020h,01fh,00fh,00fh,00fh,00fh,00fh,022h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,000h,000h
	db	020h,020h,01fh,022h,021h,022h,021h,022h,00fh,021h,00fh,00fh,00fh,00fh,00fh,00fh,000h,000h
	db	020h,020h,0dbh,00fh,021h,00fh,00fh,021h,00fh,018h,021h,021h,00fh,00fh,00fh,00fh,000h,000h
	db	020h,020h,020h,022h,00fh,00fh,00fh,00fh,00fh,015h,02eh,020h,00fh,00fh,00fh,00fh,000h,000h
	db	020h,020h,020h,020h,016h,016h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,000h,000h
	db	020h,020h,020h,00fh,00fh,019h,00fh,00fh,00fh,00fh,00fh,00fh,023h,00fh,00fh,00fh,000h,000h
	db	020h,020h,020h,022h,022h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,023h,00fh,00fh,023h,000h,000h
	db	020h,020h,020h,020h,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,020h,00fh,00fh,021h,000h,000h
	db	020h,020h,020h,020h,020h,020h,022h,00fh,00fh,00fh,00fh,023h,00fh,00fh,00fh,0dbh,000h,000h
	db	020h,020h,020h,020h,020h,020h,02fh,00fh,018h,00fh,00fh,020h,00fh,00fh,00fh,021h,020h,000h
	db	020h,020h,020h,020h,020h,020h,020h,00fh,00fh,00fh,00fh,020h,022h,00fh,00fh,00fh,023h,000h
	db	020h,020h,020h,020h,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,021h,022h,00fh,021h,000h
	db	020h,020h,020h,020h,00fh,00fh,018h,00fh,00fh,018h,018h,00fh,00fh,00fh,021h,00fh,00fh,021h
	db	020h,020h,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh
	db	020h,020h,00fh,00fh,00fh,00fh,00fh,020h,00fh,00fh,00fh,019h,00fh,00fh,00fh,00fh,00fh,00fh
	db	020h,00fh,00fh,00fh,00fh,00fh,019h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,023h,022h
	db	00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,023h,000h,000h

BIG2A:
	db	000h,000h,009h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,009h,000h,000h
	db	000h,000h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,000h,000h
	db	000h,000h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,000h,000h
	db	000h,000h,089h,089h,089h,089h,089h,089h,08bh,08bh,089h,089h,089h,089h,089h,089h,000h,000h
	db	000h,000h,089h,089h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,089h,089h,089h,089h,000h,000h
	db	000h,000h,000h,089h,08bh,08bh,08bh,08bh,08bh,08bh,00bh,08bh,089h,089h,089h,089h,000h,000h
	db	000h,000h,000h,089h,08bh,08bh,08bh,08bh,08bh,08bh,089h,08bh,089h,089h,089h,089h,000h,000h
	db	000h,000h,000h,089h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,089h,089h,089h,000h,000h
	db	000h,000h,000h,089h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,089h,089h,089h,000h,000h
	db	000h,000h,000h,000h,000h,089h,08bh,08bh,08bh,08bh,08bh,08bh,089h,089h,089h,089h,000h,000h
	db	000h,000h,000h,000h,000h,000h,08bh,08bh,08bh,08bh,08bh,08bh,089h,089h,089h,089h,000h,000h
	db	000h,000h,000h,000h,000h,000h,009h,089h,08bh,08bh,08bh,000h,089h,089h,089h,089h,089h,000h
	db	000h,000h,000h,000h,000h,000h,089h,089h,08bh,08bh,08bh,000h,089h,089h,089h,089h,089h,000h
	db	000h,000h,000h,000h,08bh,08dh,08bh,08bh,08bh,08bh,08bh,08dh,08bh,08bh,089h,089h,089h,000h
	db	000h,000h,000h,08bh,08bh,08dh,08bh,08bh,08bh,08bh,08bh,08dh,08bh,08bh,08bh,089h,089h,089h
	db	000h,000h,08bh,08bh,08dh,08bh,08bh,08bh,08bh,08bh,08dh,08bh,08bh,08bh,08bh,089h,089h,089h
	db	000h,08bh,08bh,08dh,08dh,08bh,08bh,08bh,08bh,08dh,08dh,08bh,08bh,08bh,08bh,089h,089h,089h
	db	08bh,08bh,08dh,08dh,08dh,08dh,08bh,08bh,08dh,08dh,08dh,08dh,08bh,08bh,08bh,089h,089h,089h
	db	08bh,08bh,08dh,08dh,08dh,08dh,08dh,08dh,08dh,08dh,08dh,08dh,08bh,08bh,08bh,089h,000h,000h

BIG3:
	db	020h,020h,020h,020h,00fh,00fh,00fh,00fh,021h,020h,020h,020h,020h,00fh,00fh,00fh,00fh,000h,000h
	db	020h,020h,020h,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,022h,00fh,00fh,00fh,000h,000h
	db	020h,020h,020h,020h,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,023h,020h,022h,00fh,00fh,000h,000h
	db	020h,020h,020h,020h,00fh,023h,00fh,020h,00fh,020h,00fh,00fh,020h,020h,020h,00fh,00fh,000h,000h
	db	020h,020h,020h,020h,00fh,020h,00fh,020h,00fh,020h,022h,022h,020h,01fh,00fh,021h,023h,000h,000h
	db	020h,020h,020h,020h,019h,021h,00fh,020h,00fh,021h,021h,00fh,0dbh,01fh,00fh,00fh,021h,020h,000h
	db	020h,020h,020h,00fh,022h,00fh,00fh,021h,00fh,015h,02eh,022h,020h,020h,022h,00fh,00fh,021h,000h
	db	020h,020h,00fh,00fh,027h,014h,00fh,00fh,00fh,00fh,00fh,00fh,020h,00fh,019h,022h,00fh,00fh,00fh
	db	020h,020h,00fh,023h,01fh,00fh,019h,00fh,00fh,00fh,00fh,00fh,019h,023h,02fh,020h,022h,00fh,00fh
	db	020h,00fh,023h,020h,01fh,022h,00fh,00fh,00fh,00fh,00fh,00fh,019h,02fh,020h,020h,020h,020h,022h
	db	00fh,00fh,020h,020h,01fh,01fh,022h,021h,00fh,00fh,00fh,00fh,019h,000h,000h,000h,000h,000h,000h
	db	00fh,023h,020h,020h,0dbh,01fh,020h,022h,00fh,00fh,00fh,00fh,02fh,000h,000h,000h,000h,000h,000h
	db	00fh,020h,020h,020h,020h,020h,020h,020h,020h,00fh,00fh,00fh,020h,00fh,00fh,00fh,00fh,00fh,00fh
	db	00fh,020h,020h,020h,020h,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh
	db	00fh,020h,020h,020h,020h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh
	db	022h,021h,020h,020h,020h,00fh,00fh,019h,020h,00fh,00fh,00fh,019h,00fh,023h,000h,000h,000h,000h
	db	020h,020h,020h,020h,00fh,00fh,00fh,019h,00fh,00fh,00fh,00fh,019h,00fh,000h,000h,000h,000h,000h
	db	020h,020h,020h,00fh,00fh,00fh,00fh,019h,00fh,00fh,00fh,00fh,00fh,023h,020h,000h,000h,000h,000h
	db	020h,020h,020h,022h,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,00fh,000h,000h,000h,000h,000h,000h

BIG3A:
	db	000h,000h,000h,000h,08ah,08ah,08ah,08ah,08ah,000h,000h,000h,08ah,08ah,08ah,08ah,08ah,000h,000h
	db	000h,000h,000h,000h,08ah,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08ah,08ah,08ah,08ah,000h,000h
	db	000h,000h,000h,000h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,000h,08ah,08ah,08ah,000h,000h
	db	000h,000h,000h,000h,08bh,08bh,08bh,000h,08bh,000h,08bh,08bh,000h,000h,000h,08ah,08ah,000h,000h
	db	000h,000h,000h,000h,08bh,000h,08bh,000h,08bh,000h,08bh,08bh,000h,08bh,08bh,08bh,08ah,000h,000h
	db	000h,000h,000h,08bh,08bh,08bh,08bh,000h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,000h,000h
	db	000h,000h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,00fh,08bh,000h,000h,08bh,08bh,08bh,08bh,000h
	db	000h,000h,08bh,08bh,00bh,08bh,08bh,08bh,08bh,08bh,08ch,08bh,000h,08bh,0b0h,08bh,08bh,08bh,08bh
	db	000h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,0b0h,08bh,00bh,000h,08bh,08bh,08bh
	db	08bh,08bh,08bh,000h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,0b0h,00bh,000h,000h,000h,000h,08bh
	db	08bh,08bh,000h,000h,08bh,08bh,08bh,08bh,089h,08bh,08bh,08bh,0b0h,000h,000h,000h,000h,000h,000h
	db	08bh,08bh,000h,000h,08bh,08bh,000h,08bh,08bh,08bh,08bh,08bh,00bh,000h,000h,000h,000h,000h,000h
	db	08bh,000h,000h,000h,000h,000h,000h,000h,000h,08dh,08dh,08dh,08bh,08bh,08bh,08bh,08bh,08bh,08bh
	db	08bh,000h,000h,000h,000h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh
	db	08bh,000h,000h,000h,000h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh
	db	08bh,08bh,000h,000h,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,08bh,000h,000h,000h,000h
	db	000h,000h,000h,089h,089h,089h,08bh,08bh,08bh,089h,089h,089h,08bh,08bh,000h,000h,000h,000h,000h
	db	000h,000h,000h,089h,089h,089h,089h,089h,089h,089h,089h,089h,089h,08bh,000h,000h,000h,000h,000h
	db	000h,000h,000h,089h,089h,089h,089h,08bh,089h,089h,089h,089h,089h,000h,000h,000h,000h,000h,000h

PUTEND:
	end
